#include <stdio.h>
#include <stdlib.h>
#include <string.h>



static unsigned int get_word(unsigned char *p){
	return (p[0] | (p[1] << 8));
}

static unsigned long get_dword(unsigned char *p){
	return (p[0] | (p[1] << 8) | (p[2] << 16) | (p[3] << 24));
}



#define f_get(t) t=(flag&0x80); flag<<=1; flag_count-=1
#define f_chk() if(0>=flag_count){ flag=src[ofs]; ofs+=1; flag_count=8; }


static int expand(unsigned char *dest, long dest_size, unsigned char *src, long src_size){
	long ofs;
	long dest_ofs;
	int flag;
	int flag_count;
	int t_len;
	long t_ofs;
	int t;

	ofs = 0;
	dest_ofs = 0;
	flag_count = 0;
	while(ofs < src_size){
		if(dest_size <= dest_ofs){
			break;
		}

		f_chk();
		f_get(t);
		if(0 == t){
			dest[dest_ofs] = src[ofs];
			dest_ofs += 1;
			ofs += 1;
			continue;
		}

		f_chk();
		f_get(t);
		if(0 == t){
			t_len = 0;
			f_chk();
			f_get(t);
			if(0 != t){
				t_len |= 2;
			}
			f_chk();
			f_get(t);
			if(0 != t){
				t_len |= 1;
			}
			t_len += 2;
			t_ofs = src[ofs];
			t_ofs += 1;
			ofs += 1;
		}
		else{
			t_ofs = get_word(src + ofs);
			ofs += 2;
			t_len = (t_ofs & 7);
			t_ofs = ((t_ofs >> 3) + 1);
			if(0 == t_len){
				t_len = src[ofs];
				ofs += 1;
				if(0 == t_len){
					break;
				}
				t_len += 7;
			}
			t_len += 2;
		}

		t = t_ofs;
		t_ofs = (dest_ofs - t_ofs);
		while(0 < t_len){
			if(t_len < t){
				t = t_len;
			}
			memcpy((dest + dest_ofs), (dest + t_ofs), t);
			dest_ofs += t;
			t_len -= t;
			t *= 2;
		}
	}

	return dest_ofs;
}




static int gml_div(unsigned char *src, long src_size, char *base_name){
	char t_name[256];
	FILE *fp;
	int num, ofs;
	long t_ofs, t_size;
	int k;

	num = get_word(src);
	ofs = get_word(src + 2);
	ofs += 4;

	k = 0;
	while(num > k){
		k += 1;

		t_ofs = (get_word(src + ofs) << 4);
		ofs += 2;
		t_size = get_word(src + ofs);
		ofs += 2;

		sprintf(t_name, "%s_%02d.DAT", base_name, k);

		if(0 == memcmp((src + t_ofs), "DPX0", 4)){
			long t;
			char *buf;
			t = get_dword(src + t_ofs + 8);
			buf = malloc(t + 32);
			if(NULL == buf){
				return 1;
			}
			t = expand(buf, t, (src + t_ofs + 0x10), (t_size - 0x10));
			fp = fopen(t_name, "wb");
			fwrite(buf, 1, t, fp);
			fclose(fp);
			free(buf);
		}
		else{
			fp = fopen(t_name, "wb");
			fwrite((src + t_ofs), 1, t_size, fp);
			fclose(fp);
		}
	}

	return 0;
}


static int dpx0_expand(unsigned char *src, long src_size, char *dest_name){
	FILE *fp;
	char *buf;
	long t;

	t = get_dword(src + 8);
	buf = malloc(t + 32);
	if(NULL == buf){
		return 1;
	}
	t = expand(buf, t, (src + 0x10), (src_size - 0x10));

	fp = fopen(dest_name, "wb");
	fwrite(buf, 1, t, fp);
	fclose(fp);

	free(buf);

	return 0;
}


static int gmdl_expand(unsigned char *src, long src_size, char *dest_name){
	FILE *fp;
	char *buf;
	long t;

	t = get_word(src + 10);
	t <<= 4;
	buf = malloc(t);
	if(NULL == buf){
		return 1;
	}
	t = expand(buf, t, (src + 0x20), (src_size - 0x20));

	fp = fopen(dest_name, "wb");
	fwrite(buf, 1, t, fp);
	fclose(fp);

	free(buf);

	return 0;
}



int main(int argc, char *argv[]){
	char *src;
	long src_size;
	char dest_name[64];
	int ec;

	if(2 > argc){
		printf("val_exp.exe [infile] (outfile)\n");
		exit(0);
	}


	if(3 > argc){
		char *p;
		strcpy(dest_name, argv[1]);
		p = strrchr(dest_name, '.');
		if((NULL != p) && ('\\' != p[1])){
			p[0] = '\0';
		}
	}
	else{
		strcpy(dest_name, argv[2]);
	}


	{
		FILE *fp;
		fp = fopen(argv[1], "rb");
		if(NULL == fp){
			printf("%s ݂܂\n", argv[1]);
			exit(1);
		}
		fseek(fp, 0, SEEK_END);
		src_size = ftell(fp);
		fseek(fp, 0, SEEK_SET);
		src = malloc(src_size);
		if(NULL == src){
			fclose(fp);
			printf("sł\n");
			exit(1);
		}
		fread(src, 1, src_size, fp);
		fclose(fp);
	}


	if(0 == memcmp(src, "GMDL", 4)){
		if(3 > argc){
			strcat(dest_name, ".BIN");
		}
		ec = gmdl_expand(src, src_size, dest_name);
	}
	else if(0 == memcmp(src, "DPX0", 4)){
		if(3 > argc){
			strcat(dest_name, ".DAT");
		}
		ec = dpx0_expand(src, src_size, dest_name);
	}
	else{
		ec = gml_div(src, src_size, dest_name);
	}

	free(src);
	exit(ec);
}
